> For the complete documentation index, see [llms.txt](https://docs.maple.finance/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.maple.finance/technical-resources/syrup/base-erc20-structure.md).

# Base ERC20 Structure

The core of the SYRUP token is based on the audited and battle-tested [ERC20](https://github.com/maple-labs/erc20) contract. The existing ERC20 contract used for xSYRUP and all existing pools will serve as the foundation for MPL V2. The ERC20 contract provides the following functions:

### Public Functions

* `approve()`: Allows one account to set the allowance of another account over their tokens.
* `decreaseAllowance()`: Allows one account to decrease the allowance of another account over their tokens.
* `increaseAllowance()`: Allows one account to increase the allowance of another account over their tokens.
* `permit()`: Approve by signature.
* `transfer()`: Moves an amount of tokens from `msg.sender` to a specified account.
* `transferFrom()`: Moves a pre-approved amount of tokens from a sender to a specified account.

### Internal Functions

* `_mint()`: Creates new tokens for a given account and increases the total supply.
* `_burn()`: Removes tokens from an account and decreases the total supply.

### Additional Rules

At construction time, the SYRUP should do a one time mint of 10% of the supply directly to the treasury. Additionally 10 Million SYRUP will be minted to the migrator contract to facilitate a 1-1 swap from MPL V1 to SYRUP.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.maple.finance/technical-resources/syrup/base-erc20-structure.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
